<template>
  <div>
    <status-indicator-tag
      @click="modals.show('picker', $event)"
      class="text-sm"
      v-if="task.isDate && !task.isDone()"
      :status="today ? 'emphasized' : pending ? 'deemphasized' : overdue ? 'negative' : undefined"
    >
      <i :class="`hero calendar solid mr-2 ${pending ? 'text-gray-500' : ''}`"></i>
      <div>
        {{
          today
            ? "today"
            : overdue
            ? task.overdueSince()?.as("days") + " days ago"
            : task.postponedUntil?.toLocaleString({ weekday: "short", month: "short", day: "2-digit" })
        }}
      </div>
    </status-indicator-tag>
    <modal :is="modals.get('picker')" :task="task" />
  </div>
</template>

<script lang="ts">
import Picker from "./TaskDatePicker.vue";
import { useModals } from "@/use/modal";
import Task from "@/models/Task";
import { computed } from "vue";
import StatusIndicatorTag from "../StatusIndicatorTag.vue";

export default {
  components: { StatusIndicatorTag },
  props: {
    task: {
      type: Task,
      required: true
    }
  },
  setup(props) {
    const modals = useModals({ Picker });
    return {
      modals,
      overdue: computed(() => props.task.isOverdue() && props.task.isDate),
      today: computed(() => props.task.isToday() && props.task.isDate),
      pending: computed(() => props.task.isPending() && props.task.isDate)
    };
  }
};
</script>
